ifeq ($(shell uname -m), x86_64)
	EXTRA_FLAGS = -march=$(OPTIMIZE)
else
ifeq ($(shell uname -m), i686)
	EXTRA_FLAGS = -march=$(OPTIMIZE)
else
	EXTRA_FLAGS =
endif
endif

EXTRA_FLAGS += -ffast-math -funroll-loops -fomit-frame-pointer

ifeq ($(GCC_VER_MAJOR),3)
ifeq ($(GCC_VER_MINOR),4)
EXTRA_FLAGS += -ftracer -funit-at-a-time
endif
ifeq ($(GCC_VER_MINOR),3)
EXTRA_FLAGS += -ftracer
endif
endif

ifeq ($(DEBUG),yes)
# use -Wno-long-long to make taglib happy
EXTRA_FLAGS = -g -Wall -pedantic -W -Wno-sign-compare -Wold-style-cast -Wundef -Wshadow -Wno-long-long
OPTIMIZATION = -O0
else
OPTIMIZATION = -O3
endif

ifeq ($(COMMONCPP2_LOCAL),yes)
# -D_GNU_SOURCE is for compiling libcommoncpp2 with gcc 2.95.4
EXTRA_FLAGS += -D_GNU_SOURCE
endif

# Do not strip the binaries at installation
ifeq ($(DEBUG),yes)
INSTALLSTRIP = 
else
INSTALLSTRIP = -s
endif

STDFLAGS = -I/usr/local/include -I/usr/include/ -I. \
	 -pthread -pipe $(OPTIMIZATION) $(EXTRA_FLAGS)

ifeq ($(COMMONCPP2_LOCAL),no)
COMMON_LIBS += $(COMMONCPP2_LIBS)
STDFLAGS += $(COMMONCPP2_CFLAGS)
endif

CXXFLAGS = $(STDFLAGS) -fno-exceptions

CXX=g++

C=gcc

.SUFFIXES: .cpp .c .o
.cpp.o: ; $(CXX) $(CXXFLAGS) -c $<
.c.o: ; $(C) $(STDFLAGS) -c $<

DO_MAKE = @ for i in $(SUBDIRS); do $(MAKE) -C $$i; done
DO_MAKECLEAN = @ for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done
