#ifndef KERNELHEADERS_HPP
#define KERNELHEADERS_HPP

#define CDROM_SELECT_SPEED	0x5322  /* Set the CD-ROM speed */
#define CDROM_DISC_STATUS	0x5327  /* Get disc type, etc. */
#define CDROMREADTOCHDR		0x5305  /* Read TOC header (struct cdrom_tochdr) */

/* drive status possibilities returned by CDROM_DRIVE_STATUS ioctl */
#define CDS_NO_INFO		0	/* if not implemented */
#define CDS_NO_DISC		1
#define CDS_TRAY_OPEN		2
#define CDS_DRIVE_NOT_READY	3
#define CDS_DISC_OK		4

/* return values for the CDROM_DISC_STATUS ioctl */
/* can also return CDS_NO_[INFO|DISC], from above */
#define CDS_AUDIO		100
#define CDS_DATA_1		101
#define CDS_DATA_2		102
#define CDS_XA_2_1		103
#define CDS_XA_2_2		104
#define CDS_MIXED		105

typedef unsigned char __u8;

/* This struct is used by the CDROMREADTOCHDR ioctl */
struct cdrom_tochdr 	
{
	__u8	cdth_trk0;	/* start track */
	__u8	cdth_trk1;	/* end track */
};

#endif
