#ifndef NOTIFY_HPP
#define NOTIFY_HPP

#include "functor.hpp"

#include <string>
#include <vector>
#include <list>
#include <set>

struct notify_item
{
  std::string plugin_name;
  std::list<std::string> dirs;
  TimeFv *func;

  bool operator<(const notify_item& other) const
  {
    return plugin_name < other.plugin_name;
  }
};

class Notify : public ost::Thread
{
  // updater
  void check_for_changes();
  int notify_timeout();

  std::vector<notify_item> dirs_watching;
  std::set<notify_item> needs_update;
  
  void run();

  ost::Mutex lock;

public:

  Notify();
  ~Notify();

  void register_plugin(const std::string& name, const std::list<std::string>& dirs, TimeFv *func);
  // returns all the plugins that needs to update
  const std::set<notify_item> get_plugins();
};

typedef Singleton<Notify> S_Notify;

#endif
