#ifndef GRAPHICAL_MOVIE_HPP
#define GRAPHICAL_MOVIE_HPP

#include "movie_db.hpp"
#include "singleton.hpp"

#include <list>
#include <string>

class GraphicalMovie : public MovieDB
{
private:
  // commands
  void secondary_menu();
  void enter_dir();
  void go_back();

  bool rdir_internal(const std::string& filename, const std::string& argv, 
		     std::vector<CIMDBMovie> &cur_files, bool& db_load_succes);
  void insert_file_into_db(const std::string& filename, const std::string& parent);
  int db_id(const std::string& file, bool is_dir);
  std::vector<std::string> check_db_for_folders(const std::string& parent);

  void reenter(int id);
  std::vector<std::pair<std::string, int> > gen_search_list(const std::string& search_word);

  int find_position_in_folder_list(const std::list<std::string>& files, const std::string& filename);

  std::vector<CIMDBMovie> parse_dir(const std::list<std::string>& dirs);
  std::vector<CIMDBMovie> rdir(const std::string& argv);

  bool imdb_message_not_displayed;

  virtual void save_runtime_settings();
  virtual void load_runtime_settings();

public:

  GraphicalMovie();

  void startup_updater();

  std::string mainloop();
};

#endif
