#ifndef GUILISTCONTROL_HPP
#define GUILISTCONTROL_HPP

#include "guicontrol.hpp"
#include "guilistitem.hpp"
#include <string>
#include <vector>

namespace pymms {

namespace gui {

class GUIListControl : public GUIControl
{
  protected:
    std::string font, rgb, rgbfocus, alignment;
    std::string image_focus, image_nofocus;
    int textoffset, itemheight, itemspace, pos;
    std::vector<GUIListItem*> items; 

  public:
    GUIListControl(int x, int y, int w, int h, int l, std::string foc, std::string nofoc, 
		   std::string f="Vera", std::string rgb="0xffffff", std::string rgbfocus="0xffffff", 
		   int tos=0, std::string alig="left", int itemh=30, int itemsp=0);
    virtual ~GUIListControl();
    void set_labelfont(std::string f);
    void set_labelrgb(std::string rgb);
    void set_labelrgbfocus(std::string rgbfocus);
    void set_itemheight(int itemh);
    void set_itemspace(int itemsp);
    bool add_item(GUIListItem *item);
    void clear();
    void free_resources();
    GUIListItem *get_selected_item();
    int get_selected_position();
    bool on_action(std::string action);
    void render();
};

}

}

#endif
