#ifndef MMSPYTHON_HPP
#define MMSPYTHON_HPP

#include "mmspythread.hpp"
#include <cc++/thread.h>
#include "singleton.hpp"
#include <string>
#include <vector>

namespace pymms {

typedef struct {
	int id;
	bool bDone;
	std::string strFile;
	MMSPyThread *pyThread;
} PyElem;

typedef std::vector<PyElem> PyList;

class MMSPython
{
  public:
    MMSPython();
    void initialize();

    int scripts_size();
    int get_pythonscript_id(int scriptPosition); 
    int eval_file(std::string src);

    bool is_running(int scriptId);
    void set_done(int id);


    // returns NULL if script doesn't exist or if script doesn't have a filename
    const char* get_filename(int scriptId);

    // returns -1 if no scripts exist with specified filename
    int get_scriptid(std::string strFile);

    PyThreadState *get_mainthread_state();

  private:
    int nextid;
    PyThreadState *mainThreadState;
    bool bInitialized;

    //Vector with list of threads used for running scripts
    PyList vecPyList;
    ost::Mutex m_critSection;
};

typedef Singleton<MMSPython> S_MMSPython;

}

#endif
