import os
import mmsv2gui

class MyItem(mmsv2gui.ListItem):
	def __init__(self, label):
		self.set_label(label)

class Windowexample1(mmsv2gui.Window):
	def __init__(self):

		self.text = "Navigate between the controls by pressing keys left, right, prev and next. Activate them by pressing the action key."

		self.label = mmsv2gui.LabelControl(230, 100, self.get_width() - 230, 30)
		self.textbox = mmsv2gui.TextBoxControl(250, 100, self.get_width() - 300, self.get_height() - 300)
		self.textbox.set_text(self.text)

		self.button1 = mmsv2gui.ButtonControl(50, 100, 160, 40, "Button1", focus="button-focus.png", nofocus="button-nofocus.png", textoffset=15)
		self.button2 = mmsv2gui.ButtonControl(50, 150, 160, 40, "Button2", focus="button-focus.png", nofocus="button-nofocus.png", textoffset=15)
		self.button3 = mmsv2gui.ButtonControl(50, 200, 160, 40, "Button3", focus="button-focus.png", nofocus="button-nofocus.png", textoffset=15)
		self.button4 = mmsv2gui.ButtonControl(50, 250, 160, 40, "Button4", focus="button-focus.png", nofocus="button-nofocus.png", textoffset=15)
		self.button5 = mmsv2gui.ButtonControl(50, 300, 160, 40, "Button5", focus="button-focus.png", nofocus="button-nofocus.png", textoffset=15)
		self.button7 = mmsv2gui.ButtonControl(self.get_width() - 100, self.get_height() - 100, 50, 50, focus="sub-exit-focus.gif", nofocus="sub-exit-nofocus.png")
		self.button6 = mmsv2gui.ButtonControl(self.get_width() - 160, self.get_height() - 100, 50, 50, focus="sub-info-focus.gif", nofocus="sub-info-nofocus.png")

		self.listbg = mmsv2gui.ImageControl(self.get_width() - 245, self.get_height() - 310, 150, 210, "subpanel.png")
		self.list = mmsv2gui.ListControl(self.get_width() - 225, self.get_height() - 300, 100, 180, focus="list-focus.png", nofocus="list-nofocus.png", alignment="center")

		self.add_control(self.label)
		self.add_control(self.textbox)
		self.add_control(self.button1)
		self.add_control(self.button2)
		self.add_control(self.button3)
		self.add_control(self.button4)
		self.add_control(self.button5)
		self.add_control(self.button6)
		self.add_control(self.button7)
		
		self.add_control(self.listbg)
		self.add_control(self.list)
		self.listbg.set_visible(False)
		self.list.set_visible(False)
		
		self.button1.control_right(self.button6)
		self.button2.control_right(self.button6)
		self.button3.control_right(self.button6)
		self.button4.control_right(self.button6)
		self.button5.control_right(self.button6)
		
		self.button1.control_next(self.button2)
		self.button1.control_prev(self.button5)
		self.button2.control_next(self.button3)
                self.button2.control_prev(self.button1)
		self.button3.control_next(self.button4)
                self.button3.control_prev(self.button2)
		self.button4.control_next(self.button5)
                self.button4.control_prev(self.button3)
		self.button5.control_next(self.button1)
                self.button5.control_prev(self.button4)
		self.button6.control_right(self.button7)
		self.button6.control_left(self.button1)
		self.button6.control_prev(self.list)
		self.button7.control_left(self.button6)

		self.set_focus(self.button1)
		
		for i in range(15):
 			self.list.add_item(MyItem("item " + str(i)))

	def on_action(self, action):
		#Importent to catch some action, otherwise user can't close window

		self.label.set_label("")
		self.textbox.set_visible(False)
		if action == "back" and self.list.get_visible():
			self.listbg.set_visible(False)
                        self.list.set_visible(False)
			self.set_focus(self.button6)
                if action == "action":
			if self.get_focus() == self.button1:
				self.label.set_label("You pressed button 1")
			elif self.get_focus() == self.button2:
                                self.label.set_label("You pressed button 2")
			elif self.get_focus() == self.button3:
                                self.label.set_label("You pressed button 3")
			elif self.get_focus() == self.button4:
                                self.label.set_label("You pressed button 4")
			elif self.get_focus() == self.button5:
                                self.label.set_label("You pressed button 5")
			elif self.get_focus() == self.button6:
				self.label.set_label("Press the back key to close sub menu")
				self.listbg.set_visible(True)
                        	self.list.set_visible(True)
			elif self.get_focus() == self.button7:
				self.close()
			elif self.get_focus() == self.list:
                                self.label.set_label("You pressed the sub menu: " + self.list.get_selected_item().get_label())

win = Windowexample1()
win.do_modal()

del win
