#include "gui/guibuttoncontrol.hpp"

pymms::gui::GUIButtonControl::GUIButtonControl(int x, int y, int w, int h, std::string t, int l, std::string foc, 
				   std::string nofoc, std::string f, std::string rgb, std::string rgbfocus, 
				   int tos, std::string alig, int cutoff) : GUIControl(x, y, w, h, l)
{
  text = t;
  font = f;
  this->rgb = rgb;
  this->rgbfocus = rgbfocus;
  image_focus = foc;
  image_nofocus = nofoc;
  textoffset = tos;
  alignment = alig;
  this->cutoff = cutoff;
}

std::string pymms::gui::GUIButtonControl::get_label()
{
  ost::MutexLock lock(guicontrol_mutex);
  return text;
}

void pymms::gui::GUIButtonControl::set_label(std::string t)
{
  ost::MutexLock lock(guicontrol_mutex);
  text = t;
}

void pymms::gui::GUIButtonControl::set_labelfont(std::string f)
{
  ost::MutexLock lock(guicontrol_mutex);
  font = f;
}

void pymms::gui::GUIButtonControl::set_labelrgb(std::string rgb)
{
  ost::MutexLock lock(guicontrol_mutex);
  this->rgb = rgb;
}

void pymms::gui::GUIButtonControl::set_labelrgbfocus(std::string rgbfocus)
{
  ost::MutexLock lock(guicontrol_mutex);
  this->rgbfocus = rgbfocus;
}

void pymms::gui::GUIButtonControl::render()
{
  ost::MutexLock lock(guicontrol_mutex);
  GUIImageControl *image = 0;
  GUILabelControl *label = 0;

  label = new GUILabelControl(x, y, width - cutoff, height, text,
                layer + 1, font, focus?rgbfocus:rgb, textoffset, alignment);
  label->render();
  delete label;
  label = 0;
  
  image = new GUIImageControl(x, y, width, height, 
		focus?image_focus:image_nofocus, layer);
  image->render();
  delete image;
  image = 0;
}  
