#include "gui/guiimagecontrol.hpp"

#include "pic_object.hpp"
#include "libfspp.hpp"

pymms::gui::GUIImageControl::GUIImageControl(int x, int y, int w, int h, std::string p, 
				 int l) : GUIControl(x, y, w, h, l)
{
  renderer = S_Render::get_instance();

  if(file_exists(p))
    path = p;
  else if(p.length() > 0)
    path = renderer->default_path + p;
}

void pymms::gui::GUIImageControl::render()
{
  ost::MutexLock lock(guicontrol_mutex);
  if((path.length() > 0) && file_exists(path))
    renderer->current.add(new PObj(path, x, y, width, height, false, layer));
}  
