#include "config.h"
#include "plugins.hpp"
#include "config.hpp"

#include "player/videoplayer.hpp"

#include <vector>

pymms::player::VPlayer::VPlayer() : movieplayer_mutex("movieplayer")
{
  movie_player_set = false;
  Config *conf = S_Config::get_instance();
  Plugins *plugins = S_Plugins::get_instance();

  for (std::vector<MoviePlayerPlugin*>::const_iterator iter=plugins->movie_players.begin(),
         iend=plugins->movie_players.end(); iter!=iend; ++iter) {
    if( (*iter)->plugin_name() == "MPlayer" )
    {
      movieplayer = (*iter)->player;
      movie_player_set = true;
      break;
    }
  }

  if(!movie_player_set)
    DialogWaitPrint pdialog(gettext("No MPlayer support detected"), 2000);

}

void pymms::player::VPlayer::play(std::string path, bool window)
{
  #ifdef c_movie
  ost::MutexLock lock(movieplayer_mutex);
  if(movie_player_set)
  {
    movieplayer->play_movie(path, window);
  }
  #endif
}

void pymms::player::VPlayer::pause()
{
  #ifdef c_movie
  ost::MutexLock lock(movieplayer_mutex);
  if(movie_player_set)
  {
    movieplayer->pause();
  }
  #endif
}

void pymms::player::VPlayer::stop()
{
  #ifdef c_movie
  ost::MutexLock lock(movieplayer_mutex);
  if(movie_player_set)
  {
    movieplayer->stop();
  }
  #endif
}

