#include "guiwindowdialog.hpp"
#include "gui/guiimagecontrol.hpp"
#include "gui/guiwindowmanager.hpp"

pymms::gui::GUIWindowDialog::GUIWindowDialog(std::string h, std::string l1, std::string l2, std::string l3)
{
  add_control(new GUIImageControl(get_width()/2-256, get_height()/2-108, 512, 216, "python/dialog.png", 1));
  header = new GUILabelControl(get_width()/2-256+58, get_height()/2-108+13, 512-90, 30, h, 3);
  add_control(header);
  line1 = new GUILabelControl(get_width()/2-256+58, get_height()/2-108+22+30, 512-90, 25, l1, 3);
  add_control(line1);
  line2 = new GUILabelControl(get_width()/2-256+58, get_height()/2-108+22+30+25, 512-90, 25, l2, 3);
  add_control(line2);
  line3 = new GUILabelControl(get_width()/2-256+58, get_height()/2-108+22+30+25+25, 512-90, 25, l3, 3);
  add_control(line3);  
}

pymms::gui::GUIWindowDialog::~GUIWindowDialog()
{
  if(controls.size())
  {
    for (std::vector<GUIControl*>::iterator i = controls.begin(),
          end = controls.end(); i != end; i++) {
      (*i)->free_resources();
      delete *i;
    }
  }
}

void pymms::gui::GUIWindowDialog::do_modal()
{
  dialogEvent.wait();
  dialogEvent.reset();
}

void pymms::gui::GUIWindowDialog::set_header(std::string h)
{
  header->set_label(h);
  S_WindowManager::get_instance()->render();
}

void pymms::gui::GUIWindowDialog::set_line1(std::string l1)
{
  line1->set_label(l1);
  S_WindowManager::get_instance()->render();
}

void pymms::gui::GUIWindowDialog::set_line2(std::string l2)
{
  line2->set_label(l2);
  S_WindowManager::get_instance()->render();
}

void pymms::gui::GUIWindowDialog::set_line3(std::string l3)
{
  line3->set_label(l3);
  S_WindowManager::get_instance()->render();
}
