#ifndef GUIWINDOWDIALOG_HPP
#define GUIWINDOWDIALOG_HPP

#include "input.hpp"

#include "gui/guiwindow.hpp"
#include "gui/guilabelcontrol.hpp"

#include <cc++/thread.h>
#include <string>

namespace pymms {

namespace gui {

class GUIWindowDialog : public GUIWindow
{
  protected:
    ost::Event dialogEvent;
    GUILabelControl *header, *line1, *line2, *line3;

  public: 
    GUIWindowDialog(std::string h="", std::string l1="", std::string l2="", std::string l3="");
    virtual ~GUIWindowDialog();
    virtual bool on_action(std::string action)=0;
    void do_modal();
    void set_header(std::string h="");
    void set_line1(std::string l1="");
    void set_line2(std::string l2="");
    void set_line3(std::string l3="");
};

}

}
    
#endif

