#ifndef PYCONTROL_HPP
#define PYCONTROL_HPP

#include <Python.h>
#include "structmember.h"

#include "gui/guicontrol.hpp"
#include "gui/guilabelcontrol.hpp"
#include "gui/guiimagecontrol.hpp"
#include "gui/guibuttoncontrol.hpp"
#include "gui/guilistcontrol.hpp"
#include "gui/guitextboxcontrol.hpp"
#include "gui/guirectanglecontrol.hpp"
#include "pylistitem.hpp"

#include <vector>

using namespace pymms::gui;

#define Control_Check(op) PyObject_TypeCheck(op, &Control_Type)

#ifdef __cplusplus
extern "C" {
#endif

namespace pymms {

namespace python {

typedef struct {
  PyObject_HEAD
  GUIControl *guicontrol;
} Control;

typedef struct {
  PyObject_HEAD
  GUIImageControl *guicontrol;
} ImageControl;

typedef struct {
  PyObject_HEAD
  GUILabelControl *guicontrol;
} LabelControl;

typedef struct {
  PyObject_HEAD
  GUIButtonControl *guicontrol;
} ButtonControl;

typedef struct {
  PyObject_HEAD
  GUIListControl *guicontrol;
  std::vector<ListItem*> items;
} ListControl;

typedef struct {
  PyObject_HEAD
  GUITextBoxControl *guicontrol;
} TextBoxControl;

typedef struct {
  PyObject_HEAD
  GUIRectangleControl *guicontrol;
} RectangleControl;

extern PyTypeObject Control_Type;
extern PyTypeObject ImageControl_Type;
extern PyTypeObject LabelControl_Type;
extern PyTypeObject ButtonControl_Type;
extern PyTypeObject ListControl_Type;
extern PyTypeObject TextBoxControl_Type;
extern PyTypeObject RectangleControl_Type;

}

}

#ifdef __cplusplus
}
#endif

#endif
