#include "python.hpp"

#include "libfspp.hpp"
#include "input.hpp"
#include "busy_indicator.hpp"

#include "gui/guiwindowmanager.hpp"

#include "python_config.hpp"

using namespace std;
using namespace pymms::gui;

Python::Python() 
{
}

Python::~Python()
{
}

void Python::startup_updater()
{
}

std::string Python::mainloop()
{
   Config *conf = S_Config::get_instance();
   BusyIndicator &busy_indicator = BusyIndicator::get_instance();

   PythonConfig *python_conf = S_PythonConfig::get_instance();
   GUIWindowManager *windowmanager = S_WindowManager::get_instance();
   
   InputMaster *input_master = S_InputMaster::get_instance();
   Input input;

   if(file_exists(python_conf->p_script_dir()))
   {
     input_master->parse_keys("python", "1");
     input_master->set_map("python");

     slwindow = new GUIWindowScriptLauncher(python_conf->p_script_dir());
     windowmanager->register_window(slwindow);
     windowmanager->set_active_window(slwindow);

     while(true)
     {
       busy_indicator.idle();

       input = input_master->device->get_input();
       
       busy_indicator.busy();

       if(!windowmanager->on_action(input.command))
         if(input.command == "back")
           break;
	 else
 	   global->check_commands(input);
     }

     windowmanager->unregister_window(slwindow);
     delete slwindow;

     input_master->set_map("default");
   }
   else
     DialogWaitPrint pdialog(gettext((python_conf->p_script_dir() + " does not exist").c_str()), 2000);

   return "";
}
  
Python::PythonOpts::PythonOpts() 
{
  // header
  header = "Python Options";
  translated_header = gettext("Python Options");

  // reload
  std::vector<std::string> none;
  reload_u = new Option(false, gettext("reload"), "reload", 0, none, none);
  val.push_back(reload_u);

  // sorting order
  val.push_back(go->dir_order);
}

void Python::PythonOpts::read_dirs()
{
}

Python::PythonOpts::~PythonOpts() 
{
  delete reload_u;
}
