#ifndef SINGLETON_HPP
#define SINGLETON_HPP

template <class T>
class Singleton
{
public:
  static T* get_instance() {
    static T _instance;
    return &_instance;
  }
private:
  Singleton();
  ~Singleton();
  Singleton(Singleton const&);
  Singleton& operator=(Singleton const&);
};

#endif
