#ifndef STARTMENU_HPP
#define STARTMENU_HPP

#include "config.hpp"
#include "options.hpp"
#include "themes.hpp"
#include "functor.hpp"
#include "singleton.hpp"
#include "global.hpp"

class startmenu_item
{
public:
  std::string name;
  std::string action;
  std::string pic;
  int id;
  VoidFunctor func;

  startmenu_item(const std::string& n, const std::string& a, const std::string& p, int i, const VoidFunctor& f);
};

struct startmenu_row
{
  std::string name;
  std::list<startmenu_item> items;
};

class Startmenu
{
private:
  std::list<startmenu_row> startmenu;

  Global *global;

  void print_options(const std::string& marking);
  void print(const startmenu_row& row, const startmenu_item& current_item);
  void print_lcd_menu(const startmenu_row& row, const startmenu_item& current_item);

  class StartmenuOpts : public Options 
  {
  public:
    ~StartmenuOpts();

    void set_options();
    void save();
    void load();

  private:

    void read_dirs() {};

    Option *a_o, *m_o, *p_o, *g_o;
  };

  Config *conf;

public:

  Startmenu();
  
  void print_status();

  void generate_startmenu();

  std::string mainloop();

  StartmenuOpts opts;
};

typedef Singleton<Startmenu> S_Startmenu;

#endif
